#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include "mirsak.h"
#include "run_ctrl.h"
#include "state.h"
#include "serial_ctrl.h"
#include "direction.h"
#include "number.h"
#include "comm.h"

#define CAM_USS_DIF 2

static int mirsak_rush_endflag = 0;


void mirsak_rush(){
	mirsak_rush_endflag = 0;
	int count = 1;
	int dist;
	int num[2];


	run_ctrl_create(110,32,0,50); // right:wall,50:rot 0
	
	while(1){
		if(run_ctrl_endflag_get() == 1){
			break;
		}		usleep(20 * 1000);
	}
	run_ctrl_cancel();

	direction_correct(38);

	run_ctrl_create(201,0,90,0); // right_rot:wall 0:rot 90
	while(1){
		if(run_ctrl_endflag_get() == 1){
			break;
		}
		usleep(20 * 1000);
	}
	run_ctrl_cancel();


	direction_correct(50);
	while(1){
		if(direction_endflag_get() == 1){
			break;
		}
		usleep(20 * 1000);
	
	}

	number_set_nums(1);
  number_detect(50);
  number_get(num);

	while(1){
		if(num[0]  == -1){
            number_detect(50);
	      		count++;
            if(count > 10){ 
              printf("数字認識失敗。\n");
              break;
            }
	    	}else{
	      		printf("数字認識成功!!\t数字:%d\n", num[0]);
			      break;
        }
	}
  char file[]="number3.data";
	//comm_put_number(num[0], file);
  //comm_put_number(num[1], "number33.data");

/*
  direction_correct(25);


	run_ctrl_create(201,0,75,0); // right_rot:wall 0:rot 90
	while(1){
		if(run_ctrl_endflag_get() == 1){
			break;
		}
		usleep(20 * 1000);
	}
	run_ctrl_cancel();



	direction_correct(25);

	run_ctrl_create(201,0,80,0); // right_rot:wall 0:rot 90
	while(1){
		if(run_ctrl_endflag_get() == 1){
			break;
		}
		usleep(20 * 1000);
	}
	run_ctrl_cancel();

*/

	mirsak_rush_endflag = 1;


	return;
}

int mirsak_rush_endflag_get(){

	return mirsak_rush_endflag;
}
